/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla Communicator client code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#include "../nsSBCharSetProber.h"

/********* Language model for: Esperanto *********/

/**
 * Generated by BuildLangModel.py
 * On: 2017-03-27 18:07:39.247781
 **/

/* Character Mapping Table:
 * ILL: illegal character.
 * CTR: control character specific to the charset.
 * RET: carriage/return.
 * SYM: symbol (punctuation) that does not belong to word.
 * NUM: 0 - 9.
 *
 * Other characters are ordered by probabilities
 * (0 is the most common character in the language).
 *
 * Orders are generic to a language. So the codepoint with order X in
 * CHARSET1 maps to the same character as the codepoint with the same
 * order X in CHARSET2 for the same language.
 * As such, it is possible to get missing order. For instance the
 * ligature of 'o' and 'e' exists in ISO-8859-15 but not in ISO-8859-1
 * even though they are both used for French. Same for the euro sign.
 */
static const unsigned char Iso_8859_3_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  0, 18, 17, 10,  2, 19, 15, 22,  3, 11,  9,  6, 13,  4,  1, /* 4X */
   14, 35,  5,  8,  7, 12, 16, 28, 34, 27, 20,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  0, 18, 17, 10,  2, 19, 15, 22,  3, 11,  9,  6, 13,  4,  1, /* 6X */
   14, 35,  5,  8,  7, 12, 16, 28, 34, 27, 20,SYM,SYM,SYM,SYM,CTR, /* 7X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 8X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 9X */
  SYM, 58,SYM,SYM,SYM,ILL, 30,SYM,SYM, 53, 59, 60, 26,SYM,ILL, 40, /* AX */
  SYM, 61,SYM,SYM,SYM,SYM, 30,SYM,SYM, 50, 62, 63, 26,SYM,ILL, 40, /* BX */
   47, 29, 45,ILL, 41, 64, 24, 42, 43, 32, 55, 48, 56, 33, 44, 49, /* CX */
  ILL, 39, 57, 31, 46, 52, 36,SYM, 21, 54, 37, 65, 38, 23, 25, 51, /* DX */
   47, 29, 45,ILL, 41, 66, 24, 42, 43, 32, 55, 48, 56, 33, 44, 49, /* EX */
  ILL, 39, 57, 31, 46, 52, 36,SYM, 21, 54, 37, 67, 38, 23, 25,SYM, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */


/* Model Table:
 * Total sequences: 1101
 * First 512 sequences: 0.9957742727867701
 * Next 512 sequences (512-1024): 0.004116648770246801
 * Rest: 0.00010907844298308975
 * Negative sequences: TODO
 */
static const PRUint8 EsperantoLangModel[] =
{
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,3,3,0,2,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,3,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,2,2,2,3,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,3,2,2,3,2,3,2,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,3,2,3,3,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,2,3,1,3,2,3,2,
  3,3,3,3,3,3,3,3,3,3,2,3,3,3,3,2,3,2,3,3,3,0,3,0,2,2,0,3,2,3,0,
  3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,2,3,3,3,3,3,0,3,0,2,2,2,2,2,3,2,
  3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,2,3,3,2,3,3,2,3,2,2,2,0,2,2,3,1,
  3,3,3,3,3,3,3,3,3,2,3,3,3,3,3,3,3,2,2,2,3,1,3,0,2,2,0,3,2,2,0,
  3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,2,2,2,3,2,2,0,2,2,0,0,0,2,0,3,2,
  3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,3,3,3,3,3,3,3,1,3,3,0,2,2,2,2,
  3,3,3,3,3,3,3,3,3,3,2,2,3,3,3,2,2,2,3,3,3,0,2,0,2,2,0,3,2,3,0,
  3,3,3,3,2,3,3,3,3,2,2,1,3,2,3,0,2,2,2,2,1,0,3,0,2,0,0,2,0,3,0,
  3,3,3,3,3,3,3,2,3,2,3,2,3,3,2,2,3,2,2,2,2,0,3,2,2,0,0,3,2,2,0,
  3,3,3,3,2,3,3,2,3,3,2,3,3,2,2,2,2,2,2,2,0,1,2,0,2,0,0,2,0,3,0,
  3,3,3,3,2,3,3,3,3,3,2,2,3,2,2,2,2,3,2,2,3,0,3,0,2,1,0,2,0,2,2,
  3,3,3,3,3,3,3,3,3,2,3,3,3,3,2,2,2,2,3,2,0,2,2,1,2,2,0,3,2,2,2,
  3,3,3,3,2,3,3,3,3,2,2,2,3,3,2,3,2,2,2,3,0,0,2,0,0,0,0,2,0,2,0,
  3,3,3,3,3,3,3,2,3,3,2,3,3,2,2,2,2,2,3,1,2,0,2,0,0,1,1,3,2,2,0,
  3,3,3,3,2,1,3,2,0,1,2,0,3,2,2,2,1,0,2,2,0,0,2,0,0,1,0,0,0,0,0,
  3,3,3,3,3,3,3,3,2,2,2,0,3,3,1,2,2,2,2,2,0,0,2,2,0,0,0,3,2,2,0,
  3,2,3,3,3,3,3,3,3,3,3,1,2,2,2,3,2,2,2,2,3,0,2,0,2,2,0,0,0,0,1,
  3,3,3,3,2,2,1,0,1,2,3,2,3,3,0,0,2,0,0,2,0,0,0,2,0,0,0,0,0,0,0,
  3,3,3,3,2,1,2,3,0,3,0,0,3,0,2,0,2,0,0,2,0,0,0,0,2,0,0,0,0,0,0,
  3,3,2,2,2,1,2,0,1,0,0,0,3,0,2,1,0,0,1,0,0,0,0,2,0,0,2,0,0,0,0,
  3,3,3,3,3,3,3,2,3,2,2,0,2,2,2,2,2,2,2,0,2,0,2,0,0,0,0,1,1,2,0,
  3,3,3,3,2,2,2,2,3,2,0,0,1,1,2,0,0,2,0,2,0,0,2,0,0,0,0,2,3,0,0,
  0,2,2,2,3,3,3,2,3,2,2,0,0,2,2,2,2,2,2,2,2,0,2,0,0,0,0,0,0,0,0,
  3,3,3,3,2,2,2,2,0,2,2,0,2,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,
};


const SequenceModel Iso_8859_3EsperantoModel =
{
  Iso_8859_3_CharToOrderMap,
  EsperantoLangModel,
  31,
  (float)0.9957742727867701,
  PR_FALSE,
  "ISO-8859-3"
};