/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla Communicator client code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#include "../nsSBCharSetProber.h"

/********* Language model for: Hungarian *********/

/**
 * Generated by BuildLangModel.py
 * On: 2017-03-27 18:57:12.744597
 **/

/* Character Mapping Table:
 * ILL: illegal character.
 * CTR: control character specific to the charset.
 * RET: carriage/return.
 * SYM: symbol (punctuation) that does not belong to word.
 * NUM: 0 - 9.
 *
 * Other characters are ordered by probabilities
 * (0 is the most common character in the language).
 *
 * Orders are generic to a language. So the codepoint with order X in
 * CHARSET1 maps to the same character as the codepoint with the same
 * order X in CHARSET2 for the same language.
 * As such, it is possible to get missing order. For instance the
 * ligature of 'o' and 'e' exists in ISO-8859-15 but not in ISO-8859-1
 * even though they are both used for French. Same for the euro sign.
 */
static const unsigned char Iso_8859_2_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  1, 15, 25, 17,  0, 24, 12, 21,  7, 22,  8,  4, 14,  5,  9, /* 4X */
   20, 34,  6,  3,  2, 19, 18, 32, 33, 16, 10,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  1, 15, 25, 17,  0, 24, 12, 21,  7, 22,  8,  4, 14,  5,  9, /* 6X */
   20, 34,  6,  3,  2, 19, 18, 32, 33, 16, 10,SYM,SYM,SYM,SYM,CTR, /* 7X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 8X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 9X */
  SYM, 58,SYM, 39,SYM, 60, 56,SYM,SYM, 36, 45, 54, 61,SYM, 42, 55, /* AX */
  SYM, 58,SYM, 39,SYM, 60, 56,SYM,SYM, 36, 45, 54, 62,SYM, 42, 55, /* BX */
   63, 11, 47, 43, 40, 64, 38, 35, 37, 13, 65, 41, 46, 28, 53, 66, /* CX */
   50, 44, 67, 26, 49, 27, 23,SYM, 48, 59, 30, 31, 29, 51, 57, 52, /* DX */
   68, 11, 47, 43, 40, 69, 38, 35, 37, 13, 70, 41, 46, 28, 53, 71, /* EX */
   50, 44, 72, 26, 49, 27, 23,SYM, 48, 59, 30, 31, 29, 51, 57,SYM, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */

static const unsigned char Windows_1250_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  1, 15, 25, 17,  0, 24, 12, 21,  7, 22,  8,  4, 14,  5,  9, /* 4X */
   20, 34,  6,  3,  2, 19, 18, 32, 33, 16, 10,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  1, 15, 25, 17,  0, 24, 12, 21,  7, 22,  8,  4, 14,  5,  9, /* 6X */
   20, 34,  6,  3,  2, 19, 18, 32, 33, 16, 10,SYM,SYM,SYM,SYM,CTR, /* 7X */
  SYM,ILL,SYM,ILL,SYM,SYM,SYM,SYM,ILL,SYM, 36,SYM, 56, 54, 42, 73, /* 8X */
  ILL,SYM,SYM,SYM,SYM,SYM,SYM,SYM,ILL,SYM, 36,SYM, 56, 54, 42, 74, /* 9X */
  SYM,SYM,SYM, 39,SYM, 58,SYM,SYM,SYM,SYM, 45,SYM,SYM,SYM,SYM, 55, /* AX */
  SYM,SYM,SYM, 39,SYM,SYM,SYM,SYM,SYM, 58, 45,SYM, 60,SYM, 60, 55, /* BX */
   75, 11, 47, 43, 40, 76, 38, 35, 37, 13, 77, 41, 46, 28, 53, 78, /* CX */
   50, 44, 79, 26, 49, 27, 23,SYM, 48, 59, 30, 31, 29, 51, 57, 52, /* DX */
   80, 11, 47, 43, 40, 81, 38, 35, 37, 13, 82, 41, 46, 28, 53, 83, /* EX */
   50, 44, 84, 26, 49, 27, 23,SYM, 48, 59, 30, 31, 29, 51, 57,SYM, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */


/* Model Table:
 * Total sequences: 1202
 * First 512 sequences: 0.9728825401754522
 * Next 512 sequences (512-1024): 0.026903967083300985
 * Rest: 0.0002134927412468443
 * Negative sequences: TODO
 */
static const PRUint8 HungarianLangModel[] =
{
  3,3,3,3,3,3,3,3,3,3,3,2,3,2,3,3,2,3,3,3,3,3,3,2,3,3,2,1,2,2,0,0,
  3,2,3,3,3,3,3,3,3,2,3,2,3,2,3,3,3,3,3,3,3,3,3,2,3,3,2,0,2,2,2,1,
  3,3,3,3,3,3,3,3,3,3,2,3,2,3,3,3,3,2,3,3,2,3,3,3,2,2,3,3,3,3,3,3,
  3,3,3,3,2,3,3,3,3,3,3,3,2,3,3,3,2,2,3,3,3,3,2,2,2,3,3,3,3,3,3,2,
  3,3,3,3,3,3,2,3,3,3,2,3,3,3,3,3,3,3,3,3,2,3,3,3,3,3,3,3,3,3,2,2,
  3,3,3,3,3,3,2,3,3,3,3,3,3,3,2,3,3,3,2,3,2,3,2,3,3,3,2,3,2,2,2,2,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,2,3,3,3,2,3,3,2,
  3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,3,3,3,3,3,2,1,3,3,3,1,2,2,2,2,
  3,3,3,3,3,3,3,3,3,3,2,3,2,3,2,3,2,2,2,3,2,2,2,3,2,2,3,2,3,3,2,2,
  2,2,3,3,3,3,3,2,3,2,3,2,3,2,3,3,2,3,3,3,3,3,2,0,3,3,2,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,3,2,2,3,2,2,3,3,3,3,2,2,
  2,2,3,3,3,3,3,3,3,2,3,1,3,2,3,3,1,3,3,2,3,2,3,0,2,3,0,0,2,0,0,0,
  3,3,3,3,3,3,3,3,3,3,2,3,3,3,2,3,3,2,3,3,2,3,3,3,3,2,3,2,2,2,2,2,
  2,2,3,3,3,3,3,2,3,2,3,0,3,2,3,3,0,3,3,2,3,3,2,0,2,3,0,0,1,2,0,0,
  3,3,2,3,3,2,2,3,2,3,3,3,2,3,3,3,2,2,2,3,3,2,2,2,2,2,3,2,3,2,3,3,
  3,3,2,3,3,2,3,3,2,3,2,3,0,3,2,3,2,2,2,3,2,2,2,2,2,2,3,3,3,2,2,2,
  3,3,3,3,2,3,2,3,3,3,3,3,2,3,3,3,2,2,3,3,2,3,2,2,2,2,2,2,3,3,2,3,
  3,3,3,3,2,3,3,3,2,3,2,3,2,3,2,2,2,2,3,3,2,2,3,3,2,2,3,3,3,2,2,2,
  3,3,2,2,2,2,2,3,2,3,0,3,2,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,2,2,2,
  2,2,3,3,3,3,3,2,3,2,2,3,3,2,3,3,2,3,2,2,2,2,2,0,2,2,1,1,1,0,0,0,
  3,3,3,3,3,2,3,3,2,3,2,3,2,3,2,2,2,2,2,3,3,3,3,3,2,3,2,2,3,3,2,1,
  3,3,2,2,2,2,2,3,2,3,1,3,2,3,2,2,2,2,2,3,2,2,2,2,2,2,2,2,3,2,2,2,
  3,3,3,2,3,3,2,2,2,3,2,3,2,3,2,2,0,3,2,3,2,2,2,2,2,2,3,1,2,2,3,2,
  1,0,3,3,3,3,3,0,3,0,3,0,2,0,2,3,0,3,3,2,2,2,2,0,2,2,0,0,0,1,0,0,
  3,3,2,2,2,2,3,3,2,3,0,2,2,3,2,2,2,1,1,2,1,2,2,3,2,2,2,3,0,3,2,2,
  3,3,2,3,2,2,2,3,3,3,3,2,2,3,2,2,2,2,2,2,1,3,1,2,2,2,2,0,3,0,0,1,
  2,2,3,3,3,3,3,3,3,2,3,2,3,2,3,3,0,3,2,2,3,2,3,2,2,3,0,0,1,1,2,0,
  3,2,3,3,3,2,3,3,3,2,3,2,2,2,2,3,0,3,3,2,2,2,3,2,2,2,0,1,2,2,2,0,
  0,2,3,2,2,3,3,2,2,2,3,0,3,0,3,2,0,2,3,0,2,0,3,0,1,2,0,0,0,0,0,0,
  0,0,3,3,3,3,2,0,3,0,2,0,3,0,2,2,0,2,2,0,1,2,2,1,0,2,0,1,0,0,0,0,
  0,2,3,3,3,3,2,2,2,0,2,2,3,0,1,2,0,2,2,1,1,2,3,0,2,2,0,0,1,0,0,0,
  2,1,2,2,3,2,2,2,3,0,2,0,2,1,2,2,0,1,3,2,0,2,2,0,2,2,0,0,2,0,0,0,
};


const SequenceModel Iso_8859_2HungarianModel =
{
  Iso_8859_2_CharToOrderMap,
  HungarianLangModel,
  32,
  (float)0.9728825401754522,
  PR_FALSE,
  "ISO-8859-2"
};

const SequenceModel Windows_1250HungarianModel =
{
  Windows_1250_CharToOrderMap,
  HungarianLangModel,
  32,
  (float)0.9728825401754522,
  PR_FALSE,
  "WINDOWS-1250"
};